class Charge:
    MIN = 100
    charge_count = 0
    def __init__(self, charge_type, amount):
        print("Constructor getting executed")
        self.charge_type     = charge_type
        self.amount          = amount if amount > Charge.MIN else Charge.MIN
        print("Incrementing charge_count")
        Charge.charge_count  += 1 # can also be set via self.charge_count

    def __repr__(self):
        return f"Charge({self.charge_type!r}, {self.amount!r})"
  
    def __str__(self):
        return f"Charge Object, charge_type={self.charge_type}, amount={self.amount}"
    
    def __del__(self):
        Charge.charge_count -= 1
        print("Destructor completed.")
        
    @classmethod
    def how_many_charges(cls):
        return f"No. of charges = {Charge.charge_count}"
        
    
if __name__ == "__main__":
    print("Let's create an instance of Charge called chg")
    chg = Charge("Base", 10)
    print()
    
    print('*' * 20)
    print("Object chg's attributes are:")
    print(chg.charge_type)
    print(chg.amount)
    
    print("\nLet's check how many charges we have")
    print(Charge.how_many_charges())
    print()
    
    print('*' * 20)
    print("Now let's see class and object representations.")
    print("The default representation of class Charge: ")
    print(Charge)
    print()
    
    print("Invoking our customized repr() on 'chg', we get --")
    print(repr(chg))
    print()
    print("Calling print with object name invokes its str() method.\nHere it is for chg --")
    print(chg)
    print()
    
    print('*' * 20)
    print("We should be able to construct an object back\nwith the return value of repr()\n")
    print("Creating an object 'd' with repr and eval")
    d = eval(repr(chg))
    
    print("\nLet's check how many charges we have")
    print("but this time we'll call the class method on object 'd'")
    print(f"{d.how_many_charges()}")
    
    print()
    print("Let's set d's amount to 2000 and print it")
    d.amount = 2000
    print(d.amount)
    print()
